#if GTEST
#include <gtest/gtest.h>
#include <limits>
#include <math.h>

#include "Spherical.h"

#define FLOAT_INFINITY std::numeric_limits<float>::infinity()

TEST(Spherical, FromVector3) {
  Vector3 v = Vector3(0, 0, 1);
  Spherical s = Spherical(v);

  EXPECT_FLOAT_EQ(s.distance, 1.0F) << "s.distance 0 0 1";
  EXPECT_FLOAT_EQ(s.horizontalAngle, 0.0F) << "s.hor 0 0 1";
  EXPECT_FLOAT_EQ(s.verticalAngle, 0.0F) << "s.vert 0 0 1";

  v = Vector3(0, 1, 0);
  s = Spherical(v);

  EXPECT_FLOAT_EQ(s.distance, 1.0F) << "s.distance 0 1 0";
  EXPECT_FLOAT_EQ(s.horizontalAngle, 0.0F) << "s.hor 0 1 0";
  EXPECT_FLOAT_EQ(s.verticalAngle, 90.0F) << "s.vert 0 1 0";

  v = Vector3(1, 0, 0);
  s = Spherical(v);

  EXPECT_FLOAT_EQ(s.distance, 1.0F) << "s.distance 1 0 0";
  EXPECT_FLOAT_EQ(s.horizontalAngle, 90.0F) << "s.hor 1 0 0";
  EXPECT_FLOAT_EQ(s.verticalAngle, 0.0F) << "s.vert 1 0 0";
}
#endif